您的位置:首页 > 其它

[leetcode] Two Sum

2014-11-06 15:36 316 查看
Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2)
are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9

Output: index1=1, index2=2

(超时)暴力求解方法:

public int[] twosum(int[]numbers, int target){
int[] result=new int[2];
int len=numbers.length;
int sum;

for(int i=0;i<len-1;i++){
for(int j=i+1;j<len;j++){
sum=numbers[i]+numbers[j];
if(sum==target){
result[0]=i+1;
result[1]=j+1;
}
}
}
return result;

}


利用Hashmap,首先遍历数组,将numbers[index]=value, 存入hashmap<value,index>;然后遍历数组,在hashmap中寻找对应的值。

public class Solution {
public int[] twoSum(int[] numbers, int target) {
int[] result=new int[2];
int len=numbers.length;
Map<Integer, Integer> map = new HashMap<Integer, Integer>();

for(int i=0;i<len;i++){
map.put(numbers[i], i);
}

for(int one=0;one<len;one++){
Integer two=map.get(target-numbers[one]);
if(two!=null && one<two){
result[0]=one+1;
result[1]=two+1;
}
}
return result;
}
}


In addtion:

Map<Integer,Integer> map=new HashMap<Integer,Integer>(); //新建map
map.put(numbers[i],i) // put(key,value) 存入键值

map.get(numbers[i]); //get(key)取值
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: